%define log_dir /var/www/html/logs
%define daemon_user monitor
%if 0%{?suse_version}
%define htmlroot /srv/www/htdocs
%define httpconfdir apache2/conf.d
%define daemon_group www
%else
%define htmlroot /var/www/html
%define httpconfdir httpd/conf.d
%define daemon_group apache
%endif

Summary: A set of daemons to handle incoming logmessages and snmp traps.
Name: monitor-passive
Version: 3.2.2
Release: op5.1
Group: op5/monitor
License: op5 Immaterial Rights License
Vendor: op5 Development Team
Prefix: /opt/monitor/op5
Obsoletes: traphandler, loghandler
Source: %name-%version.tar.gz
BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}

%if 0%{?sles_version}
Requires: php53
Requires: php53-pcntl
Requires: apache2
%else
Requires: php
Requires: httpd
%if 0%{?rhel:%{rhel}} >= 6
Requires: php-process >= 5.3.3
%endif
%endif
Requires: op5-monitor-user
Requires: net-snmp, syslog, monitor
Requires: monitor-passive-logs
Requires: monitor-passive-traps

%description
The op5 Passive Monitoring Tools is a set of daemons used to gather
status information from remote nodes via either the syslog mechanism
or the SNMP trap protocol.

%package traps
Version: 3.2.2
Release: op5.1
Group: op5/monitor
License: op5 Immaterial Rights License
Requires: monitor-passive
Summary: SNMP trap receiver

%description traps
op5 Passive Traps is used to gather status information from remote
nodes via the SNMP trap protocol.

%package logs
Version: 3.2.2
Release: op5.1
Group: op5/monitor
License: op5 Immaterial Rights License
Requires: monitor-passive
Summary: Syslog receiver

%description logs
op5 Passive Logs is used to gather status information from remote
nodes via the syslog mechanism.

%prep
%setup -q
%if 0%{?suse_version}
patch -p1 < sles.patch
find -type f -exec %{__sed} '{}' -i -e 's#var/www/html#srv/www/htdocs#g'  \;
%endif

%install
rm -rf %buildroot

echo `pwd`

mkdir -p -m 755 %buildroot%prefix/{passive,loghandler}
mkdir -p %buildroot%_sysconfdir/%httpconfdir
mkdir -p %buildroot%_sysconfdir/init.d
mkdir -p %buildroot%_sysconfdir/logrotate.d
mkdir -p %buildroot%_sysconfdir/snmp
mkdir -p -m 775 %buildroot/var/www/html/logs

install -m 755 loghandler.php %buildroot%prefix/passive/loghandler.php
install -m 700 loghandler.init %buildroot/etc/init.d/loghandler
install -m 600 passive.logrotate %buildroot/etc/logrotate.d/passive
install -m 640 monitor-passive.conf.httpd %buildroot/etc/%httpconfdir/monitor-passive.conf
install -m 755 traphandler.sh %buildroot%prefix/passive
install -m 640 snmptrapd.conf %buildroot/etc/snmp/op5-snmptrapd.conf
install -m 640 snmptrapd.options %buildroot/etc/snmp/op5-snmptrapd.options


%post logs
# add syslog options properly
if [ $1 -eq 1 ]; then
	sed -i "s/^SYSLOGD_OPTIONS=.*/SYSLOGD_OPTIONS='-m 0 -r'/" \
		/etc/sysconfig/syslog >& /dev/null || :
	# Check if we're on centos5. We're not, but let's call this "inspiration
	# for future fixes" or something - it prevents error messages during install
	# of a feature nobody wants anyway.
	if [ -e /etc/syslog.conf ]; then
		grep -q /opt/monitor/op5/loghandler/log_pipe /etc/syslog.conf 2>/dev/null ||
			echo -e "\nuser.notice                        |/opt/monitor/op5/loghandler/log_pipe" \
				>> /etc/syslog.conf
	fi
fi

# the init script takes care of restarting its feeder daemons
chkconfig --add loghandler
/etc/init.d/loghandler restart

%post traps
if [ $1 -eq 1 ]; then
	chkconfig --add snmptrapd
	if [ -x /etc/init.d/snmptrapd ]; then
		/etc/init.d/snmptrapd stop || :
		/etc/init.d/snmptrapd start || :
	fi

	if [ -f /etc/snmp/snmptrapd.conf ];then
		mv /etc/snmp/snmptrapd.conf /etc/snmp/snmptrapd.conf.bk
		ln -s /etc/snmp/op5-snmptrapd.conf /etc/snmp/snmptrapd.conf
	fi
	if [ -f /etc/snmp/snmptrapd.options ];then
		mv /etc/snmp/snmptrapd.options /etc/snmp/snmptrapd.options.bk
		ln -s /etc/snmp/op5-snmptrapd.options /etc/snmp/snmptrapd.options
	fi
fi

%postun logs
if [ $1 -eq 0 ]; then
	chkconfig --del loghandler
fi

%postun traps
if [ $1 -eq 0 ]; then
	chkconfig --del snmptrapd
fi

%files
%defattr(-,root,root)
%prefix/passive
%attr(775,%daemon_user,%daemon_group) %dir /var/www/html/logs
/etc/logrotate.d/passive
%attr(-,root,%daemon_group) /etc/%httpconfdir/monitor-passive.conf

%files traps
%defattr(-,root,root)
%config /etc/snmp/op5-snmptrapd.conf
%config /etc/snmp/op5-snmptrapd.options
%doc README.traphandler

%files logs
%defattr(-,root,root)
%attr(700,root,root) /etc/init.d/loghandler
%attr(775,%daemon_user,%daemon_group) %prefix/passive/loghandler.php
%doc README.loghandler
